#!/usr/bin/env bash
# Applicable license : MIT from OSC

S_IMAGE=/shared/home/haessigj/icarus.sif

<%-
  # Helper
  cache_root = Pathname.new("${CACHE_DIR}")

  # Configure R
  r_script = session.staged_root.join("launcher.R")
  # r_env    = "module load intel/16.0.3 R/3.4.2"

  #TODO: could we source a .env file in /users/PZS0562/efranz/awesim/dev/bc_osc_example_shiny/app
  # not to be confused by https://github.com/gaborcsardi/dotenv
  r_env = "export DATASET=/users/PZS0562/efranz/awesim/dev/bc_osc_example_shiny/app/data/hista_alignment"
  r_cmd = "R"
  r_dataset = ""

  # Configure Shiny
  # app_path = session.staged_root.join("app")
  app_path = '/pvol/ICARUS'
  app_sock = cache_root.join("app.sock")

  # Configure NGINX
  nginx_conf  = session.staged_root.join("nginx.conf")
  nginx_logs  = session.staged_root.join("logs")
  nginx_cache = cache_root.join("nginx")
  nginx_env   = "module load singularity"
  nginx_cmd   = <<-EOS.gsub(/^ {4}/, "")
    singularity run \
      -B "#{nginx_conf}:/usr/local/openresty/nginx/conf/nginx.conf" \
      -B "#{nginx_logs}:/usr/local/openresty/nginx/logs/" \
      -B "#{nginx_cache}" \
      -B "#{app_sock.dirname}" \
      /shared/home/haessigj/openresty.sif
  EOS
-%>

#
# Create Shiny App launcher script
#

echo "Creating Shiny App launcher..."
(
umask 077
sed 's/^ \{2\}//' > "<%= r_script %>" << EOT
sock <- "<%= app_sock %>"
  attr(sock, "mask") <- strtoi("0077", 8)
  options(shiny.port = sock)
  options(shiny.launch.browser = FALSE)
  shiny::runApp("<%= app_path %>")
EOT
)

# mountpoint for logs
mkdir -p "<%= nginx_logs %>"

#
# Create NGINX configuration file
#

echo "Creating NGINX config..."
(
umask 077
mkdir -p "<%= nginx_cache %>"
sed 's/^ \{2\}//' > "<%= nginx_conf %>" << EOT
  daemon off;
  pid <%= nginx_cache %>/nginx.pid;
  worker_processes 1;

  events {
    worker_connections 1024;
  }

  http {
    client_body_temp_path <%= nginx_cache %>/client_body_temp;
    proxy_temp_path       <%= nginx_cache %>/proxy_temp;
    fastcgi_temp_path     <%= nginx_cache %>/fastcgi_temp;
    uwsgi_temp_path       <%= nginx_cache %>/uwsgi_temp;
    scgi_temp_path        <%= nginx_cache %>/scgi_temp;

    map \$http_upgrade \$connection_upgrade {
      default upgrade;
      ''      close;
    }

    server {
      listen ${port};
      client_max_body_size 10G;
      location /icarusauth {
        content_by_lua_block {
          function dump(o)
            if type(o) == 'table' then
              local s = '{ '
              for k,v in pairs(o) do
                if type(k) ~= 'number' then k = '"'..k..'"' end
                s = s .. '['..k..'] = ' .. dump(v) .. ','
              end
              return s .. '} '
            else
              return tostring(o)
            end
          end

          ngx.req.read_body()
          local args, err = ngx.req.get_post_args()
          if not args then
            ngx.status=ngx.HTTP_FORBIDDEN
            ngx.say("failed to get post args: ", err)
            return
          end
          if args and args.password == "${password}" then
            local session = require "resty.session".start()
            session.data.authenticated = true
            session:save()
          else
            ngx.status=ngx.HTTP_FORBIDDEN
            ngx.say("Query args were : " .. dump(args))
            ngx.exit(ngx.HTTP_FORBIDDEN)
            return
          end
          return ngx.redirect("/")
        }
      }

      location / {
        access_by_lua_block {
          local session = require "resty.session".open()
          if session.data.authenticated ~= true then
            ngx.exit(ngx.HTTP_FORBIDDEN)
          end
        }
        proxy_pass http://unix:<%= app_sock %>:/;
        proxy_http_version 1.1;
        proxy_set_header Upgrade \$http_upgrade;
        proxy_set_header Connection \$connection_upgrade;
        proxy_read_timeout 7d;
      }
    }
  }
EOT
)

# Set working directory to home directory
cd "${HOME}"

#
# Start Shiny App server
#

(
umask 077

# Load the required environment
#<%= r_env %>

#source <%= app_path + "/env" %>

# Output debug info
module list
module load singularity
# Launch Shiny App
#set -x
#<%= r_cmd %> --no-save --slave -f "<%= r_script %>"

singularity run -B "<%= r_script %>" $S_IMAGE R --no-save --slave -f "<%= r_script %>"

) &






#
# Wait until Unix socket is created
#

TIME=60
FOUND=0
echo "Waiting ${TIME} seconds until Unix socket is created..."
for ((i=1; i<=TIME*2; i++)); do
  if [[ -e "<%= app_sock %>" ]]; then
    FOUND=1
    echo "Found socket file!"
    break
  fi
  sleep 0.5
done
[[ ${FOUND} -eq 0 ]] && echo "ERROR: Failed to find socket file!" && exit 1

#
# Start NGINX server
#

# Load required environment
<%= nginx_env %>

# Output debug info
module list

# Launch NGINX server
set -x
<%= nginx_cmd %>



